/*
 * Created on 18.05.2005 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2446 $
 *  $Date: 2006-09-12 14:57:25 +0200 (Di, 12 Sep 2006) $
 *  $Id: Get2AttributesDialog.java 2446 2006-09-12 12:57:25Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.ui.dialogs;

import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JSeparator;

import com.vividsolutions.jump.feature.AttributeType;
import com.vividsolutions.jump.feature.FeatureCollection;
import com.vividsolutions.jump.feature.FeatureSchema;

import de.fhOsnabrueck.jump.pirol.ui.panels.GetAttributePanel;
import de.fhOsnabrueck.jump.pirol.ui.panels.OkCancelButtonPanel;
import de.fhOsnabrueck.jump.pirol.ui.tools.DialogTools;

/**
 * dialog that asks for two attributes.
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2446 $
 * 
 */
public class Get2AttributesDialog extends JDialog implements ActionListener {

    private static final long serialVersionUID = -8741601703698146570L;
    
    protected GetAttributePanel attrPanel1 = null, attrPanel2 = null;
    protected OkCancelButtonPanel okCancelPanel = null; 
    protected String dialogText = null;
    
    protected FeatureSchema featureSchema = null;
    private boolean valueSet = false;

    /**
     *@param parent
     *@param title
     *@param modal
     *@throws java.awt.HeadlessException
     */
    public Get2AttributesDialog(Frame parent, String title, String text, boolean modal, FeatureCollection featureCollection)
            throws HeadlessException {
        super(parent, title, modal);
        this.featureSchema = featureCollection.getFeatureSchema();
        this.dialogText = text;
        
        this.setupDialog();
    }
    
    public Get2AttributesDialog(Frame parent, String title, String text, boolean modal, FeatureSchema featureSchema)
            throws HeadlessException {
        super(parent, title, modal);
        this.featureSchema = featureSchema;
        this.dialogText = text;
        
        this.setupDialog();
    }
    
    private void setupDialog(){
        FeatureSchema fs = this.featureSchema;
        
        JPanel texts = DialogTools.getPanelWithLabels(this.dialogText,50);
        
        AttributeType[] validAttributeTypes = new AttributeType[]{AttributeType.INTEGER, AttributeType.DOUBLE}; 
        this.attrPanel1 = new GetAttributePanel(fs, validAttributeTypes);
        this.attrPanel2 = new GetAttributePanel(fs, validAttributeTypes);
        
        this.okCancelPanel = new OkCancelButtonPanel();
        this.okCancelPanel.addActionListener(this);
        
        JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(7,1));
		panel.add( texts );
		panel.add( new JSeparator(JSeparator.HORIZONTAL) );
		panel.add( this.attrPanel1 );
		panel.add( new JSeparator(JSeparator.HORIZONTAL) );
		panel.add( this.attrPanel2 );
		panel.add( new JSeparator(JSeparator.HORIZONTAL) );
		panel.add(this.okCancelPanel);
		panel.doLayout();
		
		this.getContentPane().add(panel);
		this.pack();
		
    }

    public void actionPerformed(ActionEvent arg0) {
        if (arg0.getSource().getClass() == JButton.class){
			JButton source = (JButton) arg0.getSource();

			if (source.getActionCommand().equals(this.okCancelPanel.getOkButton().getActionCommand())){
				this.valueSet = true;
			}
			this.setVisible(false);
		}
    }
    
    
    public String getAttribute1() {
        return attrPanel1.getAttribute();
    }

    public String getAttribute2() {
        return attrPanel2.getAttribute();
    }
    
    
    public boolean isValueSet() {
        return valueSet;
    }
}
